"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
exports.useChecklist = function (data, options) {
    if (data === void 0) { data = []; }
    if (options === void 0) { options = { key: 'id', keyType: 'string' }; }
    var _a = react_1.useState(new Set()), checkedItems = _a[0], setCheckedItems = _a[1];
    return {
        isCheckedAll: (!data || (data.length === 0)) ? false : (checkedItems.size === data.length),
        checkedItems: checkedItems,
        setCheckedItems: setCheckedItems,
        handleCheck: function (e) {
            var key = e.currentTarget.dataset.key;
            if (key) {
                if (options.keyType === 'number') {
                    key = parseInt(key, 10);
                }
                if (checkedItems.has(key)) {
                    checkedItems.delete(key);
                }
                else {
                    checkedItems.add(key);
                }
                return setCheckedItems(new Set(checkedItems));
            }
            if (checkedItems.size === data.length) {
                return setCheckedItems(new Set());
            }
            setCheckedItems(new Set(data.map(function (v) { return v[options.key]; })));
        },
    };
};
